<template>
  <div>
    <nuxt-link
      class="fr-link fr-icon-arrow-left-line fr-link--icon-left fr-mb-6w"
      :to="{
        name: 'offre-accompagnement-sur-mesure-catalogue',
        query: $route.query,
      }"
      >Retour à la liste</nuxt-link
    >
    <div class="anct-border-primary mrg-top">
      <div class="padding">
        <FrTitle class="fr-mb-6w" larger>{{
          ansmItem.local_authority
        }}</FrTitle>
        <div class="fr-mb-lg-6w fr-mb-2w fr-grid-row">
          <FrTitle tag="h3" class="fr-mr-2w">
            Accompagnement numérique sur mesure
          </FrTitle>
        </div>

        <fr-tag
          v-for="(program, index) in ansmItem.programs"
          :key="`ansmItem-tag--${index}`"
          :label="program"
          class="mrg-right"
        />
      </div>

      <div class="anct-flex-around border-top-bottom">
        <div v-if="ansmItem.department">
          <strong>{{ ansmItem.department }}</strong
          ><br />
          Département
        </div>

        <div v-if="ansmItem.region">
          <strong>{{ ansmItem.region }}</strong
          ><br />
          Région
        </div>

        <div v-if="ansmItem.population">
          <strong>{{ ansmItem.population }}</strong
          ><br />
          Habitants
        </div>
      </div>

      <div v-if="ansmItem.expectations" class="padding">
        <fr-title tag="h4">Besoin inital</fr-title>
        <ul class="fr-callout">
          <li
            v-for="(expectation, expectationIndex) in ansmItem.expectations"
            :key="`expectation--${expectationIndex}`"
          >
            {{ expectation }}
          </li>
        </ul>
      </div>
    </div>
    <div>
      <fr-title
        v-if="ansmItem.need_a && ansmItem.need_a[0]"
        tag="h3"
        class="mrg-top"
        >Solutions proposées par l'accompagnement</fr-title
      >
      <FrAccordion
        v-if="
          ansmItem.need_a &&
          ansmItem.solution_a &&
          ansmItem.solution_a[0].isOpenSource
        "
        id="need_a"
        v-model="accordion.need_a"
        :title="ansmItem.need_a[0]"
        collapse-blue
      >
        <fr-cards-container class="fr-mr-2w">
          <fr-card
            v-for="(solution, solutionIndex) in ansmItem.solution_a"
            v-show="solution.isOpenSource"
            :key="`solution-card--${solutionIndex}`"
            :to="{ path: solution.url }"
            :title="solution.name"
          >
            <template #description>
              <p v-if="solution.editor" class="fr-card__detail">
                {{ solution.editor }}
              </p>

              <p class="fr-text--sm">Solution open source</p>

              <fr-external-link-button
                title="external link"
                :href="solution.url"
                >En savoir plus</fr-external-link-button
              >
            </template>
          </fr-card>
        </fr-cards-container>
      </FrAccordion>

      <FrAccordion
        v-if="
          ansmItem.need_b &&
          ansmItem.solution_b &&
          ansmItem.solution_b[0].isOpenSource
        "
        id="need_b"
        v-model="accordion.need_b"
        :title="ansmItem.need_b[0]"
        collapse-blue
      >
        <fr-cards-container class="fr-mr-2w">
          <fr-card
            v-for="(solution, solutionIndex) in ansmItem.solution_b"
            v-show="solution.isOpenSource"
            :key="`solution-card--${solutionIndex}`"
            :to="{ path: solution.url }"
            :title="solution.name"
          >
            <template #description>
              <p v-if="solution.editor" class="fr-card__detail">
                {{ solution.editor }}
              </p>

              <p class="fr-text--sm">Solution open source</p>

              <fr-external-link-button
                title="external link"
                :href="solution.url"
                >En savoir plus</fr-external-link-button
              >
            </template>
          </fr-card>
        </fr-cards-container>
      </FrAccordion>

      <FrAccordion
        v-if="
          ansmItem.need_c &&
          ansmItem.solution_c &&
          ansmItem.solution_c[0].isOpenSource
        "
        id="need_c"
        v-model="accordion.need_c"
        :title="ansmItem.need_c[0]"
        collapse-blue
      >
        <fr-cards-container class="fr-mr-2w">
          <fr-card
            v-for="(solution, solutionIndex) in ansmItem.solution_c"
            v-show="solution.isOpenSource"
            :key="`solution-card--${solutionIndex}`"
            :to="{ path: solution.url }"
            :title="solution.name"
          >
            <template #description>
              <p v-if="solution.editor" class="fr-card__detail">
                {{ solution.editor }}
              </p>

              <p class="fr-text--sm">Solution open source</p>

              <fr-external-link-button
                title="external link"
                :href="solution.url"
                >En savoir plus</fr-external-link-button
              >
            </template>
          </fr-card>
        </fr-cards-container>
      </FrAccordion>

      <FrAccordion
        v-if="
          ansmItem.need_d &&
          ansmItem.solution_d &&
          ansmItem.solution_d[0].isOpenSource
        "
        id="need_d"
        v-model="accordion.need_d"
        :title="ansmItem.need_d[0]"
        collapse-blue
      >
        <fr-cards-container class="fr-mr-2w">
          <fr-card
            v-for="(solution, solutionIndex) in ansmItem.solution_d"
            v-show="solution.isOpenSource"
            :key="`solution-card--${solutionIndex}`"
            :to="{ path: solution.url }"
            :title="solution.name"
          >
            <template #description>
              <p v-if="solution.editor" class="fr-card__detail">
                {{ solution.editor }}
              </p>

              <p class="fr-text--sm">Solution open source</p>

              <fr-external-link-button
                title="external link"
                :href="solution.url"
                >En savoir plus</fr-external-link-button
              >
            </template>
          </fr-card>
        </fr-cards-container>
      </FrAccordion>

      <FrAccordion
        v-if="
          ansmItem.need_e &&
          ansmItem.solution_e &&
          ansmItem.solution_e[0].isOpenSource
        "
        id="need_e"
        v-model="accordion.need_e"
        :title="ansmItem.need_e[0]"
        collapse-blue
      >
        <fr-cards-container class="fr-mr-2w">
          <fr-card
            v-for="(solution, solutionIndex) in ansmItem.solution_e"
            v-show="solution.isOpenSource"
            :key="`solution-card--${solutionIndex}`"
            :to="{ path: solution.url }"
            :title="solution.name"
          >
            <template #description>
              <p v-if="solution.editor" class="fr-card__detail">
                {{ solution.editor }}
              </p>

              <p class="fr-text--sm">Solution open source</p>

              <fr-external-link-button
                title="external link"
                :href="solution.url"
                >En savoir plus</fr-external-link-button
              >
            </template>
          </fr-card>
        </fr-cards-container>
      </FrAccordion>
    </div>
  </div>
</template>

<script>
import FrTitle from '~/components/ui/Title';
import FrTag from '~/components/ui/tags/Basic';
import FrExternalLinkButton from '~/components/ui/ExternalLinkButton';
import FrAccordion from '~/components/elements/Accordion';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';

export default {
  name: 'AnsmDetailPage',
  components: {
    FrExternalLinkButton,
    FrTitle,
    FrTag,
    FrAccordion,
    FrCard,
    FrCardsContainer,
  },

  async asyncData({ $axios, params, redirect, $config }) {
    const { data: ansmItemData } = await $axios.get('/items/ansm', {
      params: {
        filter: { slug: { _eq: params.slug } },
      },
    });

    const [ansmItem] = ansmItemData.data;

    if (!ansmItem) {
      return redirect({ name: 'ansm' });
    }

    return {
      ansmItem: {
        ...ansmItem,
      },
    };
  },

  data() {
    return {
      accordion: {
        description: true,
        features: true,
        territorialLevel: false,
        deploy: false,
        teams: false,
        history: false,
        partners: false,
      },
    };
  },
};
</script>

<style scoped>
/deep/ .anct-html-content blockquote {
  margin-left: 0;
  border-left: 4px solid var(--blue-france-main-525);
  padding-left: 16px;
}

/deep/ .anct-html-content blockquote p {
  margin-bottom: 0;
}

/deep/ .anct-html-content blockquote p strong {
  font-weight: normal;
}

/deep/ .anct-html-content ul,
/deep/ .anct-html-content ol {
  margin-left: 24px;
  margin-bottom: 16px;
}

/deep/ .anct-html-content ul p {
  margin-bottom: 8px;
}

/deep/ .anct-html-content h2 {
  margin-top: 48px;
}

.border-top-bottom {
  border-bottom: 1px solid var(--border-default-grey);
  border-top: 1px solid var(--border-default-grey);
  padding: 24px;
}
.mrg-top {
  margin-top: 24px;
}
.mrg-right {
  margin-right: 16px;
}

.padding {
  padding: 24px;
}
</style>
